Structure PB_StructureImage 
  Bitmap.l 
  Width.w 
  Height.w 
  Depth.w 
  ColorArray.l 
EndStructure 

Procedure IMAGE_GetOrAllocImageSpace(Number) 
  !extrn _PB_Image_GetOrAllocateID 
  !MOV Eax,[Esp] 
  !CALL _PB_Image_GetOrAllocateID 
  ProcedureReturn 
EndProcedure 

Procedure MakeImage(Number,hBitmap) 
  If GetObjectType_(hBitmap)=0:ProcedureReturn 0:EndIf 
  *ImgPtr.PB_StructureImage=IMAGE_GetOrAllocImageSpace(Number) 
  If *ImgPtr=0:ProcedureReturn 0:EndIf 
  If GetObjectType_(*ImgPtr\Bitmap):DeleteObject_(*ImgPtr\Bitmap):EndIf 
  GetObject_(hBitmap,SizeOf(BITMAP),BmpInf.BITMAP) 
  *ImgPtr\Bitmap=hBitmap 
  *ImgPtr\Width=BmpInf\bmWidth 
  *ImgPtr\Height=BmpInf\bmHeight 
  *ImgPtr\Depth=BmpInf\bmBitsPixel 
  *ImgPtr\ColorArray=0 
  UseImage(Number) 
  ProcedureReturn hBitmap 
EndProcedure 


hBmp=CreateBitmap_(400,300,1,1,0) ; create a  monochrome bitmap 

MakeImage(900,hBmp) ; MakeImage() dosen't support #PB_Any as paramenter 

StartDrawing(ImageOutput()); draw something on the bitmap 
For c=0 To 24 
  Circle(Random(400),Random(300),50,Random($FFFFFF)) 
Next 
StopDrawing() 


Flags=#PB_Window_SystemMenu|#PB_Window_MinimizeGadget|#PB_Window_ScreenCentered    
OpenWindow(1,0,0,400,300,Flags,"Use API-Bitmaps as PB-Images") 

Repeat 
  
  Event=WaitWindowEvent() 
  
  If Event=#PB_Event_Repaint 
    StartDrawing(WindowOutput()) 
    DrawImage(ImageID(),0,0) 
    StopDrawing() 
  EndIf 
  
Until Event=#PB_Event_CloseWindow
; IDE Options = PureBasic v3.94 (Windows - x86)
; CursorPosition = 55
; FirstLine = 18
; Folding = -