

#RT_VERSION=16

Procedure.s GetAppProductName()
hMod=GetModuleHandle_(0)
VersionInfo=FindResource_(hMod,1,#RT_VERSION)
If VersionInfo=0:ProcedureReturn "":EndIf

Size=SizeofResource_(hMod,VersionInfo)
If Size<=0:ProcedureReturn "":EndIf

hRes=LoadResource_(hMod,VersionInfo)
If hRes=0:ProcedureReturn "":EndIf

Addr=LockResource_(hRes)
If Addr=0:ProcedureReturn "":EndIf

AnsiAddr=GlobalAlloc_(#GMEM_ZEROINIT|#GMEM_FIXED,Size)
If AnsiAddr=0:FreeResource_(hRes):ProcedureReturn "":EndIf

WideCharToMultiByte_(#CP_ACP,0,Addr,Size,AnsiAddr,Size,0,0)

SearchLen=11
For c=0 To Size-SearchLen-1
If PeekS(AnsiAddr+c,SearchLen)="ProductName"
String$=PeekS(AnsiAddr+c+SearchLen+2)
GlobalFree_(AnsiAddr)
FreeResource_(hRes)
ProcedureReturn String$
EndIf
Next

GlobalFree_(AnsiAddr)
FreeResource_(hRes)
ProcedureReturn ""
EndProcedure


Procedure.s GetAppProductNameEx(File$)
hMod=LoadLibrary_(File$)
If hMod=0:ProcedureReturn "":EndIf
VersionInfo=FindResource_(hMod,1,#RT_VERSION)
If VersionInfo=0:FreeLibrary_(hMod):ProcedureReturn "":EndIf

Size=SizeofResource_(hMod,VersionInfo)
If Size<=0:FreeLibrary_(hMod):ProcedureReturn "":EndIf

hRes=LoadResource_(hMod,VersionInfo)
If hRes=0:FreeLibrary_(hMod):ProcedureReturn "":EndIf

Addr=LockResource_(hRes)
If Addr=0:FreeLibrary_(hMod):ProcedureReturn "":EndIf

AnsiAddr=GlobalAlloc_(#GMEM_ZEROINIT|#GMEM_FIXED,Size)
If AnsiAddr=0:FreeLibrary_(hMod):FreeResource_(hRes):ProcedureReturn "":EndIf

WideCharToMultiByte_(#CP_ACP,0,Addr,Size,AnsiAddr,Size,0,0)

SearchLen=11
For c=0 To Size-SearchLen-1
If PeekS(AnsiAddr+c,SearchLen)="ProductName"
String$=PeekS(AnsiAddr+c+SearchLen+2)
FreeLibrary_(hMod)
GlobalFree_(AnsiAddr)
FreeResource_(hRes)
ProcedureReturn String$
EndIf
Next

FreeLibrary_(hMod)
GlobalFree_(AnsiAddr)
FreeResource_(hRes)
ProcedureReturn ""
EndProcedure

Procedure.s GetAppCompanyName()
hMod=GetModuleHandle_(0)
VersionInfo=FindResource_(hMod,1,#RT_VERSION)
If VersionInfo=0:ProcedureReturn "":EndIf

Size=SizeofResource_(hMod,VersionInfo)
If Size<=0:ProcedureReturn "":EndIf

hRes=LoadResource_(hMod,VersionInfo)
If hRes=0:ProcedureReturn "":EndIf

Addr=LockResource_(hRes)
If Addr=0:ProcedureReturn "":EndIf

AnsiAddr=GlobalAlloc_(#GMEM_ZEROINIT|#GMEM_FIXED,Size)
If AnsiAddr=0:FreeResource_(hRes):ProcedureReturn "":EndIf

WideCharToMultiByte_(#CP_ACP,0,Addr,Size,AnsiAddr,Size,0,0)

SearchLen=11
For c=0 To Size-SearchLen-1
If PeekS(AnsiAddr+c,SearchLen)="CompanyName"
String$=PeekS(AnsiAddr+c+SearchLen+2)
GlobalFree_(AnsiAddr)
FreeResource_(hRes)
ProcedureReturn String$
EndIf
Next

GlobalFree_(AnsiAddr)
FreeResource_(hRes)
ProcedureReturn ""
EndProcedure


Procedure.s GetAppCompanyNameEx(File$)
hMod=LoadLibrary_(File$)
If hMod=0:ProcedureReturn "":EndIf
VersionInfo=FindResource_(hMod,1,#RT_VERSION)
If VersionInfo=0:FreeLibrary_(hMod):ProcedureReturn "":EndIf

Size=SizeofResource_(hMod,VersionInfo)
If Size<=0:FreeLibrary_(hMod):ProcedureReturn "":EndIf

hRes=LoadResource_(hMod,VersionInfo)
If hRes=0:FreeLibrary_(hMod):ProcedureReturn "":EndIf

Addr=LockResource_(hRes)
If Addr=0:FreeLibrary_(hMod):ProcedureReturn "":EndIf

AnsiAddr=GlobalAlloc_(#GMEM_ZEROINIT|#GMEM_FIXED,Size)
If AnsiAddr=0:FreeLibrary_(hMod):FreeResource_(hRes):ProcedureReturn "":EndIf

WideCharToMultiByte_(#CP_ACP,0,Addr,Size,AnsiAddr,Size,0,0)

SearchLen=11
For c=0 To Size-SearchLen-1
If PeekS(AnsiAddr+c,SearchLen)="CompanyName"
String$=PeekS(AnsiAddr+c+SearchLen+2)
FreeLibrary_(hMod)
GlobalFree_(AnsiAddr)
FreeResource_(hRes)
ProcedureReturn String$
EndIf
Next

FreeLibrary_(hMod)
GlobalFree_(AnsiAddr)
FreeResource_(hRes)
ProcedureReturn ""
EndProcedure

Procedure.s GetAppName()
Name$=Space($2000)
GetModuleFileName_(0,@Name$,$2000)
ProcedureReturn GetFilePart(Name$)
EndProcedure

Procedure.s GetAppPath()
Name$=Space($2000)
GetModuleFileName_(0,@Name$,$2000)
ProcedureReturn GetPathPart(Name$)
EndProcedure




Debug GetAppProductNameEx("d3d8.dll")
Debug GetAppCompanyNameEx("d3d8.dll")
Debug GetAppName()




; IDE Options = PureBasic v3.94 (Windows - x86)
; CursorPosition = 164
; FirstLine = 138
; Folding = --