;Use this at your own risk !

Procedure CanReadFromSegment(Segment)
  !XOR Eax,Eax
  !VERR [ESP]
  !JNZ ReadOk
  !DEC Eax 
  !ReadOk:
  ProcedureReturn 
EndProcedure

Procedure CanWriteToSegment(Segment)
  !XOR Eax,Eax
  !VERW [ESP]
  !JNZ WriteOk
  !DEC Eax 
  !WriteOk:
  ProcedureReturn 
EndProcedure

Procedure WriteSegmentByte(Segment,Offset,Byte.b)
  !PUSH ES
  !MOV Eax,[ESP+4]
  !MOV ES,AX
  !MOV Eax,[ESP+8]
  !MOV EDX,[ESP+12]
  !MOV [ES:Eax],DL
  !POP ES
EndProcedure

Procedure WriteSegmentWord(Segment,Offset,Word.w)
  !PUSH ES
  !MOV Eax,[ESP+4]
  !MOV ES,AX
  !MOV Eax,[ESP+8]
  !MOV EDX,[ESP+12]
  !MOV [ES:Eax],DX
  !POP ES
EndProcedure

Procedure WriteSegmentLong(Segment,Offset,Long)
  !PUSH ES
  !MOV Eax,[ESP+4]
  !MOV ES,AX
  !MOV Eax,[ESP+8]
  !MOV EDX,[ESP+12]
  !MOV [ES:Eax],EDX
  !POP ES
EndProcedure

Procedure.b ReadSegmentByte(Segment,Offset)
  !PUSH ES
  !MOV Eax,[ESP+4]
  !MOV ES,AX
  !MOV Eax,[ESP+8]
  !MOVSX Eax,Byte[ES:Eax]
  !POP ES
  ProcedureReturn 
EndProcedure

Procedure.w ReadSegmentWord(Segment,Offset)
  !PUSH ES
  !MOV Eax,[ESP+4]
  !MOV ES,AX
  !MOV Eax,[ESP+8]
  !MOVSX Eax,Word[ES:Eax]
  !POP ES
  ProcedureReturn 
EndProcedure

Procedure.w ReadSegmentLong(Segment,Offset)
  !PUSH ES
  !MOV Eax,[ESP+4]
  !MOV ES,AX
  !MOV Eax,[ESP+8]
  !MOV Eax,[ES:Eax]
  !POP ES
  ProcedureReturn 
EndProcedure

Procedure GetSegmentSize(Segment)
  !MOV EDX,[ESP]
  !LSL AX,DX
  !JZ ResultOk
  !XOR Eax,Eax
  !ResultOk:
  ProcedureReturn
EndProcedure

;TEST:
Debug CanWriteToSegment($40)
Debug CanReadFromSegment($40)

Debug GetSegmentSize($40)


For C=$FC00 To $FFFF
  A$+Chr(ReadSegmentByte($40,C))
Next

Debug A$

; IDE Options = PureBasic v3.94 Beta 2 - Windows x86