;NOTE:
;This only works, if the hardware blitter supports color-conversion !

Procedure GetOrAllocSprite(Sprite) 
!extrn _PB_Sprite_GetOrAllocateID 
!Call _PB_Sprite_GetOrAllocateID 
ProcedureReturn 
EndProcedure 

Procedure GetDDrawBase() 
!extrn _PB_DDrawBase 
!MOV Eax,[_PB_DDrawBase] 
ProcedureReturn 
EndProcedure 


Structure PB_Sprite 
Sprite.l 
Width.w 
Height.w 
Depth.w 
Mode.w 
FileName.l 
RealWidth.w 
RealHeight.w 
ClipX.w 
ClipY.w 
EndStructure 

Procedure CreateSharedSpriteFromTexture(Sprite,Texture) 
*SpritePtr.PB_Sprite=GetOrAllocSprite(Sprite) 
*DDS.IDirectDrawSurface7=*SpritePtr\Sprite 
If *DDS:*DDS\Release():EndIf 

*DD.IDirectDraw7=GetDDrawBase() 
DC=StartDrawing(TextureOutput(Texture)) 
*DD\GetSurfaceFromDC(DC,@*TextureDDS.IDirectDrawSurface7) 
*TextureDDS\AddRef() 
StopDrawing() 

*SpritePtr\Sprite=*TextureDDS 
*SpritePtr\Width=TextureWidth(Texture) 
*SpritePtr\Height=TextureHeight(Texture) 
*SpritePtr\Depth=0 
*SpritePtr\Mode=#PB_Sprite_Texture 
*SpritePtr\FileName=0 
*SpritePtr\RealWidth=TextureWidth(Texture) 
*SpritePtr\RealHeight=TextureHeight(Texture) 
*SpritePtr\ClipX=0 
*SpritePtr\ClipY=0 
ProcedureReturn *TextureDDS 
EndProcedure 










PBDir$="C:\PureBasic\" 


InitEngine3D() 
InitSprite() 
InitKeyboard() 
InitMovie() 

Flags=#PB_Window_SystemMenu|#PB_Window_ScreenCentered
OpenWindow(1,0,0,640,480,Flags,"TEST") 
OpenWindowedScreen(WindowID(),0,0,640,480,1,0,0) 

AmbientColor($FFFFFF) 
  
Add3DArchive(PBDir$+"Examples\Sources\Data\",#PB_3DArchive_FileSystem) 
CreateEntity(1,LoadMesh(1,"Robot.mesh"),CreateMaterial(1,LoadTexture(1,"r2skin.jpg"))) 

CreateCamera(1,0,0,100,100) 
CameraLocate(1,0,0,100) 
RotateCamera(1,0,20,0) 


LoadSprite(0,PBDir$+"Examples\Sources\Data\File.bmp") 

CreateSharedSpriteFromTexture(1,1) ; Erstellt ein sprite, das intern den gleichen Speicher wie die Textur benutzt. 



Repeat 

UseBuffer(1)  ; auf texture zeichnen 

DisplaySprite(0,Random(500),Random(500)) 

UseBuffer(-1) 


RotateEntity(1,0.5,0,0) 

ClearScreen(0,0,255) 
RenderWorld() 
FlipBuffers() 

ExamineKeyboard() 

Event=WindowEvent() 

Until KeyboardPushed(#PB_Key_Escape)
; IDE Options = PureBasic v3.94 (Windows - x86)
; CursorPosition = 97
; FirstLine = 78
; Folding = -