
Procedure Engine3D_GetDLLHandle()
ProcedureReturn GetModuleHandle_("Engine3D.dll")
EndProcedure

Procedure.s Engine3D_GetRenderSystem()
Handle=Engine3D_GetDLLHandle()
CallFunctionFast(GetProcAddress_(Handle,"ExamineDrivers3D"))
CallFunctionFast(GetProcAddress_(Handle,"NextDriver3D"))
ProcedureReturn PeekS(CallFunctionFast(GetProcAddress_(Handle,"Driver3DName")))
EndProcedure

Procedure Engine3D_GetDirectDraw7()
ProcedureReturn CallFunctionFast(GetProcAddress_(Engine3D_GetDLLHandle(),"GetDirectDraw7"))
EndProcedure

Procedure Engine3D_GetBackBuffer2()
ProcedureReturn CallFunctionFast(GetProcAddress_(Engine3D_GetDLLHandle(),"GetBackBuffer2"))
EndProcedure

Procedure Engine3D_GetFrontBuffer()
ProcedureReturn CallFunctionFast(GetProcAddress_(Engine3D_GetDLLHandle(),"GetFrontBuffer"))
EndProcedure

Procedure.s GetTextureFileName(Texture)
String=PeekL(TextureID(Texture)+4)
If String
ProcedureReturn PeekS(String)
Else
ProcedureReturn ""
EndIf
EndProcedure

Procedure GetTextureOrginalWidth(Texture)
ProcedureReturn PeekL(TextureID(Texture)+56)
EndProcedure
  
Procedure GetTextureOrginalHeight(Texture)
ProcedureReturn PeekL(TextureID(Texture)+60)
EndProcedure

Procedure GetTextureDDS(Texture)
DC=StartDrawing(TextureOutput(Texture))
*DD.IDirectDraw7=Engine3D_GetDirectDraw7()
*DDS.IDirectDrawSurface7=0
*DD\GetSurfaceFromDC(DC,@*DDS)
StopDrawing()
ProcedureReturn *DDS
EndProcedure

Procedure GetD3D7()
*DD.IDirectDraw7=Engine3D_GetDirectDraw7()
Debug "Here"
Debug *DD\QueryInterface(?IID_IDirect3D7,@*D3D)
ProcedureReturn *D3D
EndProcedure


DataSection 
IID_IDirect3DRGBDevice: 
Data.l $A4665C60 
Data.w $2673,$11CF 
Data.b $A3,$1A,$0,$AA,$0,$B9,$33,$56 

IID_IDirect3DHALDevice: 
Data.l $84E63DE0 
Data.w $46AA,$11CF 
Data.b $81,$6F,$0,$0,$C0,$20,$15,$6E 

IID_IDirect3DTnLHalDevice: 
Data.l $F5049E78 
Data.w $4861,$11D2 
Data.b $A4,$7,$0,$A0,$C9,$6,$29,$A8 

IID_IDirect3D7: 
Data.l $F5049E77 
Data.w $4861,$11D2 
Data.b $A4,$7,$0,$A0,$C9,$6,$29,$A8 
EndDataSection



InitEngine3D()
Debug Engine3D_GetRenderSystem()

; IDE Options = PureBasic v3.94 (Windows - x86)
; CursorPosition = 83
; Folding = --