;Achtung: 
;Bentigt die Userlibs E2D und SpriteEx. 

Procedure PutRotatedSprite(Sprite,XPos,YPos,Angle.f) 
  SpriteWidth=SpriteWidth(Sprite)-1 
  SpriteHeight=SpriteHeight(Sprite)-1 
  ScreenWidth=ScreenWidth()-1 
  ScreenHeight=ScreenHeight()-1 
  
  Dim SpriteArray(SpriteWidth,SpriteHeight) 
  
  StartDrawing(SpriteOutput(Sprite)) 
  For x=0 To SpriteWidth 
    For y=0 To SpriteHeight 
      SpriteArray(x,y)=PointFast(x,y) 
    Next 
  Next 
  StopDrawing() 
  
  StartDrawing(CurrentBufferOutput()) 
  
  Angle.f=(Angle*ACos(-1)*2)/360 
  
  Cos.f=Cos(Angle.f) 
  Sin.f=Sin(Angle.f) 
  NSin.f=-Sin 
  
  SpriteWidth2=SpriteWidth/2 
  SpriteHeight2=SpriteHeight/2 
  
  For x=0 To SpriteWidth 
    
    Xv=XPos+(x-SpriteWidth2)*Cos 
    Xv2=(x-SpriteWidth2)*Sin 
    
    For y=0 To SpriteHeight 
      
      Xp=Xv+(y-SpriteHeight2)*NSin 
      Yp=Xv2+(y-SpriteHeight2)*Cos+YPos 
      
      If Xp>=0 And Xp<ScreenWidth And Yp>=0 And Yp<=ScreenHeight 
        Color=SpriteArray(x,y) 
        Plot(Xp,Yp,Color) 
        Plot(Xp+1,Yp,Color) 
      EndIf 
      
    Next 
  Next 
  StopDrawing() 
  
  Dim SpriteArray(0,0) 
EndProcedure 


InitSprite() 

OpenScreen(800,600,16,"PutRotatedSprite()") 

LoadSprite(1,"tree.bmp",#PB_Sprite_Memory) 

For Angle=0 To 360 
  ClearScreen(0,0,0) 
  PutRotatedSprite(1,300,300,Angle) 
  FlipBuffers() 
Next 
; ExecutableFormat=Windows
; EOF