#DDBLT_WAIT=16777216 

Structure PB_Sprite 
  Sprite.l 
  Width.w 
  Height.w 
  Depth.w 
  Mode.w 
  FileName.l 
  RealWidth.w 
  RealHeight.w 
  ClipX.w 
  ClipY.w 
EndStructure 

Procedure ResizeSpriteWithoutFilter(Sprite,Width,Height);Gibt bei Fehler 0 zurck. 
  If Width<=0 Or Height<=0:ProcedureReturn 0:EndIf 
  
  *Sprite.PB_Sprite=IsSprite(Sprite) 
  If *Sprite=0:ProcedureReturn 0:EndIf 
  
  *DDS.IDirectDrawSurface7=*Sprite\Sprite 
  If *DDS=0:ProcedureReturn 0:EndIf 
  
  *DDS\GetDDInterface(@*DD.IDirectDraw7) 
  If *DD=0:ProcedureReturn 0:EndIf 
  
  DDSD=AllocateMemory(124) 
  If DDSD=0:*DD\Release():ProcedureReturn 0:EndIf 
  
  PokeL(DDSD,124) 
  If *DDS\GetSurfaceDesc(DDSD):*DD\Release():FreeMemory(DDSD):ProcedureReturn 0:EndIf 
  PokeL(DDSD+8,Height) 
  PokeL(DDSD+12,Width) 
  
  If *DD\CreateSurface(DDSD,@*DDS2.IDirectDrawSurface7,0):*DD\Release():FreeMemory(DDSD):ProcedureReturn 0:EndIf  
  
  *DDS\GetDC(@DC) 
  *DDS2\GetDC(@DC2) 
  SetStretchBltMode_(DC2,#COLORONCOLOR) 
  StretchBlt_(DC2,0,0,Width,Height,DC,0,0,SpriteWidth(Sprite),SpriteHeight(Sprite),#SRCCOPY) 
  *DDS\ReleaseDC(DC) 
  *DDS2\ReleaseDC(DC2) 
  
  FreeMemory(DDSD) 
  *DDS\Release() 
  *Sprite\Sprite=*DDS2 
  *Sprite\Width=Width 
  *Sprite\Height=Height 
  *Sprite\RealWidth=Width 
  *Sprite\RealHeight=Height 
  *Sprite\ClipX=0 
  *Sprite\ClipY=0 
  ProcedureReturn *DDS2 
EndProcedure 

;Test: 
InitSprite() 
InitKeyboard() 

OpenScreen(800,600,16,"ResizeSprite()") 

CreateSprite(1,128,128) 
StartDrawing(SpriteOutput(1)) 
For M=0 To 500 
  Circle(Random(128),Random(128),10,Random($FFFFFF)) 
Next 
BackColor(0,0,0) 
FrontColor(255,255,0) 
DrawingFont(GetStockObject_(#ANSI_VAR_FONT)) 
DrawText("Press enter to quit.") 
StopDrawing() 


DisplaySprite(1,0,0) 

ResizeSpriteWithoutFilter(1,256,128) 
DisplaySprite(1,128,0) 

ResizeSpriteWithoutFilter(1,256,256) 
DisplaySprite(1,384,0) 

ResizeSpriteWithoutFilter(1,100,100) 
DisplaySprite(1,640,0) 

FlipBuffers() 

Repeat 
  ExamineKeyboard() 
Until KeyboardPushed(#PB_Key_Return) 


; IDE Options = PureBasic v3.94 (Windows - x86)