;AnimationGadget
;***************


#DRAW_ANIMATION=#WM_USER+20
#DI_NORMAL=3

Procedure AnimationThread(Addr)
  Repeat
    SendMessage_(PeekL(Addr),#DRAW_ANIMATION,0,0)
    Delay(PeekL(Addr+4))
  ForEver
EndProcedure


Procedure Animation_CB(hWnd,Msg,wParam,lParam)
  Result=DefWindowProc_(hWnd,Msg,wParam,lParam)
  Addr=GetWindowLong_(hWnd,#GWL_USERDATA)
  If Addr<>0
    RE.RECT 
    GetWindowRect_(hWnd,RE) 
    WinHeight=RE\bottom-RE\top  
    WinWidth =RE\right-RE\left 
    BkBrush=GetClassLong_(GetParent_(hWnd),#GCL_HBRBACKGROUND)
    Cursor=PeekL(Addr+4)
    Frame=PeekL(Addr+12)
    
    Select Msg
      Case #DRAW_ANIMATION
        DC=GetWindowDC_(hWnd)
        If DrawIconEx_(DC,0,0,Cursor,WinWidth,WinHeight,Frame,BkBrush,#DI_NORMAL)=0  
          DrawIconEx_(DC,0,0,Cursor,WinWidth,WinHeight,0,BkBrush,#DI_NORMAL)
          PokeL(Addr+12,0)
        EndIf
        PokeL(Addr+12,PeekL(Addr+12)+1)
        ReleaseDC_(hWnd,DC)
        
      Case #WM_PAINT
        DC=GetWindowDC_(hWnd)
        If DrawIconEx_(DC,0,0,Cursor,WinWidth,WinHeight,Frame,BkBrush,#DI_NORMAL)=0 
          DrawIconEx_(DC,0,0,Cursor,WinWidth,WinHeight,0,BkBrush,#DI_NORMAL)
          PokeL(Addr+12,0)
        EndIf
        ReleaseDC_(hWnd,DC)
        
      Case #WM_DESTROY
        GlobalFree_(PeekL(Addr))
        PauseThread(PeekL(Addr+8))
        KillThread(PeekL(Addr+8))
        GlobalFree_(Addr)
        SetWindowLong_(hWnd,#GWL_USERDATA,0)
    EndSelect
  EndIf
  ProcedureReturn Result
EndProcedure



 
Procedure AnimationGadget(Nr,x,y,Width,Height,Cursor,Delay)
  Handle=ButtonGadget(Nr,x,y,Width,Height,"",#BS_OWNERDRAW)
  
  AniMem=GlobalAlloc_(#GMEM_FIXED,20)
  ThreadMem=GlobalAlloc_(#GMEM_FIXED,8)
  PokeL(ThreadMem,Handle)
  PokeL(ThreadMem+4,Delay)
  ThreadID=CreateThread(@AnimationThread(),ThreadMem)
  
  PokeL(AniMem,ThreadMem)
  PokeL(AniMem+4,Cursor)
  PokeL(AniMem+8,ThreadID)
  PokeL(AniMem+12,0)
  SetWindowLong_(Handle,#GWL_WNDPROC,@Animation_CB())
  SetWindowLong_(Handle,#GWL_USERDATA,AniMem)
  ProcedureReturn Handle
EndProcedure


Procedure.s GetWinPath()
  Path$=Space(256)
  GetWindowsDirectory_(@Path$,256)
  ProcedureReturn Path$
EndProcedure

Procedure LoadAniFile(File$)
  ProcedureReturn LoadImage_(GetModuleHandle_(0),File$,#IMAGE_CURSOR,0,0,#LR_LOADFROMFILE)
EndProcedure
 
 
 



;Example:
OpenWindow(1,0,0,160,96,#PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_SizeGadget,"AnimationGadget")
CreateGadgetList(WindowID())


Ani1=LoadAniFile(GetWinPath()+"\Cursors\HOURGLAS.ANI")

AnimationGadget(1,0,0,64,64,Ani1,100)


Repeat
  Result=WaitWindowEvent()
Until Result=#PB_Event_CloseWindow
DestroyCursor_(Ani1)



; IDE Options = PureBasic v3.94 (Windows - x86)
; Executable = ..\..\Examples.exe