;====================== DMusic ====================================
;
;==================================================================


#CLSCTX_INPROC=3  
#DMUS_OBJ_CLASS=2
#DMUS_OBJ_FILENAME=16

Structure DMUS_OBJECTDESC
  dwSize.l
  dwValidData.l
  guidObject.GUID
  guidClass.GUID
  ftDate.FILETIME
  vVersion.LARGE_INTEGER
  wszName.w[64]
  wszCategory.w[64]
  wszFileName.w[#MAX_PATH]
  llMemLength.LARGE_INTEGER
  pbMemData.l
EndStructure

Global *DMP
Global *DML
Global CoInitialize


ProcedureDLL DM_FreeDirectMusic()
  If *DMP:CallFunctionFast(PeekL(PeekL(*DMP)+8),*DMP):EndIf;= *DMP\Release()
  If *DML:CallFunctionFast(PeekL(PeekL(*DML)+8),*DML):EndIf;= *DML\Release()
  If CoInitialize:CoUninitialize_():EndIf
  ProcedureReturn 1
EndProcedure

ProcedureDLL DM_InitDirectMusic()
  If CoInitialize_(0):ProcedureReturn 0:EndIf
  CoInitialize=1
  If CoCreateInstance_(?CLSID_DirectMusicPerformance,0,#CLSCTX_INPROC,?IID_IDirectMusicPerformance2,@*DMP)
    DM_FreeDirectMusic()
    ProcedureReturn 0
  EndIf
  If CallFunctionFast(PeekL(PeekL(*DMP)+12),*DMP,0,0,0);= *DMP\Init(0,0,0)
    DM_FreeDirectMusic()
    ProcedureReturn 0
  EndIf
  If CallFunctionFast(PeekL(PeekL(*DMP)+96),*DMP,0);= *DMP\AddPort(0)
    DM_FreeDirectMusic()
    ProcedureReturn 0
  EndIf
  If CoCreateInstance_(?CLSID_DirectMusicLoader,0,#CLSCTX_INPROC,?IID_IDirectMusicLoader,@*DML)
    DM_FreeDirectMusic()
    ProcedureReturn 0
  EndIf
  ProcedureReturn 1
EndProcedure


ProcedureDLL DM_LoadMusicFromFile(File$)
  If FileSize(File$)<=0:ProcedureReturn 0:EndIf
  
  dmod.DMUS_OBJECTDESC
  dmod\dwSize=SizeOf(DMUS_OBJECTDESC)
  CopyMemory(?CLSID_DirectMusicSegment,@dmod\guidClass,16)
  dmod\dwValidData=#DMUS_OBJ_CLASS|#DMUS_OBJ_FILENAME
  
  If MultiByteToWideChar_(#CP_ACP,0,@File$,Len(File$),@dmod\wszFileName,#MAX_PATH)=0
    ProcedureReturn 0
  EndIf
  
  ;*DML\GetObject(dmod,?IID_IDirectMusicSegment,@*DMS)
  If CallFunctionFast(PeekL(PeekL(*DML)+12),*DML,dmod,?IID_IDirectMusicSegment,@*DMS)
    ProcedureReturn 0
  EndIf
  
  ;*DMS\SetParam(?GUID_StandardMIDIFile,-1,0,0,*DMP)
  If CallFunctionFast(PeekL(PeekL(*DMS)+76),*DMS,?GUID_StandardMIDIFile,-1,0,0,*DMP)
    CallFunctionFast(PeekL(PeekL(*DMS)+8),*DMS);= *DMS\Release()
    ProcedureReturn 0
  EndIf
  
  ;*DMS\SetParam(?GUID_Download,-1,0,0,*DMP)
  If CallFunctionFast(PeekL(PeekL(*DMS)+76),*DMS,?GUID_Download,-1,0,0,*DMP)
    CallFunctionFast(PeekL(PeekL(*DMS)+8),*DMS);= *DMS\Release()
    ProcedureReturn 0
  EndIf
  
  ProcedureReturn *DMS
EndProcedure

ProcedureDLL DM_PlayMusic(*DMS)
  If *DMS=0:ProcedureReturn 0:EndIf
  ;*DMP\PlaySegment(*DMS,0,0,0,0)
  If CallFunctionFast(PeekL(PeekL(*DMP)+16),*DMP,*DMS,0,0,0,0);1 Parameter zuviel?
    ProcedureReturn 0
  EndIf
  ProcedureReturn 1
EndProcedure

ProcedureDLL DM_StopMusic(*DMS)
  ;*DMP\Stop(*DMS,0,0,0)
  If CallFunctionFast(PeekL(PeekL(*DMP)+20),*DMP,*DMS,0,0,0)
    ProcedureReturn 0
  EndIf
  ProcedureReturn 1
EndProcedure  

ProcedureDLL DM_FreeMusic(*DMS)
  If *DMS=0:ProcedureReturn 0:EndIf
  CallFunctionFast(PeekL(PeekL(*DMS)+8),*DMS);= *DMS\Release()
  ProcedureReturn 1
EndProcedure

DataSection
CLSID_DirectMusicPerformance:
Data.l $D2AC2881
Data.w $B39B,$11D1 
Data.b $87,$4,$0,$60,$8,$93,$B1,$BD
  
IID_IDirectMusicPerformance2:
Data.l $6FC2CAE0
Data.w $BC78,$11D2
Data.b $AF,$A6,$0,$AA,$0,$24,$D8,$B6  
  
CLSID_DirectMusicLoader:
Data.l $D2AC2892
Data.w $B39B,$11D1
Data.b $87,$4,$0,$60,$8,$93,$B1,$BD

IID_IDirectMusicLoader:
Data.l $2FFAACA2
Data.w $5DCA,$11D2
Data.b $AF,$A6,$0,$AA,$0,$24,$D8,$B6
  
CLSID_DirectMusicSegment:
Data.l $D2AC2882
Data.w $B39B,$11D1
Data.b $87,4,$0,$60,$8,$93,$B1,$BD  
  
IID_IDirectMusicSegment:
Data.l $F96029A2
Data.w $4282,$11D2
Data.b $87,$17,$0,$60,$8,$93,$B1,$BD  

GUID_Download:
Data.l $D2AC28A7
Data.w $B39B,$11D1
Data.b $87,$4,$0,$60,$8,$93,$B1,$BD

GUID_StandardMIDIFile:
Data.l $6621075
Data.w $E92E,$11D1
Data.b $A8,$C5,$0,$C0,$4F,$A3,$72,$6E
EndDataSection

;==================================================================
;
;==================================================================




;Test:
DM_InitDirectMusic()



Music=DM_LoadMusicFromFile("C:\WINNT\Media\canyon.mid")

Debug Music

DM_PlayMusic(Music)

Delay(5000)

DM_FreeMusic(Music)
DM_FreeDirectMusic()


; IDE Options = PureBasic v3.94 (Windows - x86)
; CursorPosition = 76
; FirstLine = 61
; Folding = --