;ALPHABLENDING
;*************

;Should work also with Win 95.



Procedure AlphaBlend(DestDC,x,y,Width,Height,SrcDC,Alpha)
  Select Alpha
    Case 0
    Case 255
      BitBlt_(DestDC,x,y,Width,Height,SrcDC,0,0,#SRCCOPY)
    Default
      MemDC=CreateCompatibleDC_(DestDC)
      MemImg=CreateCompatibleBitmap_(DestDC,Width,Height)
      SelectObject_(MemDC,MemImg)
      
      BitBlt_(MemDC,0,0,Width,Height,DestDC,x,y,#SRCCOPY)
      
      SrcAddr=GlobalAlloc_(#GMEM_FIXED,(Width*Height)<<2)
      DestAddr=GlobalAlloc_(#GMEM_FIXED,(Width*Height)<<2)
      
      bmp.BITMAPINFO\bmiHeader\biPlanes=1 
      bmp\bmiHeader\biBitCount=32
      bmp\bmiHeader\biCompression=#BI_RGB 
      bmp\bmiHeader\biWidth=Width
      bmp\bmiHeader\biHeight=Height
      bmp\bmiHeader\biSize=SizeOf(BITMAPINFOHEADER)
      
      GetDIBits_(SrcDC,GetCurrentObject_(SrcDC,#OBJ_BITMAP),0,Height,SrcAddr,bmp,#DIB_RGB_COLORS)
      GetDIBits_(MemDC,MemImg,0,Height,DestAddr,bmp,#DIB_RGB_COLORS)
      
      For c=0 To ((Width-1)*(Height-1))<<2 Step 4       
        DestC=PeekL(DestAddr+c)
        SrcC=PeekL(SrcAddr+c)      
        PokeL(DestAddr+c,RGB((Red(DestC)*(255-Alpha)+Red(SrcC)*Alpha)/255,(Green(DestC)*(255-Alpha)+Green(SrcC)*Alpha)/255,(Blue(DestC)*(255-Alpha)+Blue(SrcC)*Alpha)/255))
      Next
      
      SetDIBitsToDevice_(DestDC,x,y,Width,Height,0,0,0,Height,DestAddr,bmp,#DIB_RGB_COLORS)
      
      GlobalFree_(DestAddr)
      GlobalFree_(SrcAddr)
      DeleteDC_(MemDC)
      DeleteObject_(MemImg)
  EndSelect
  
EndProcedure



flags=#PB_Window_ScreenCentered|#PB_Window_SystemMenu|#PB_Window_MinimizeGadget
OpenWindow(1,0,0,500,400,flags,"AlphaBlend (move the mouse)")

Img=LoadImage(1,"Alpha.bmp")


ImgDC=CreateCompatibleDC_(0)
SelectObject_(ImgDC,Img)


DestDC=StartDrawing(WindowOutput())
Repeat
  
  AlphaBlend(DestDC,WindowMouseX(),WindowMouseY(),128,128,ImgDC,64)
  
  Delay(10)
Until WindowEvent()=#PB_Event_CloseWindow
StopDrawing()

DeleteDC_(ImgDC)
DeleteObject_(Img)
; IDE Options = PureBasic v3.94 (Windows - x86)
; CursorPosition = 32
; FirstLine = 25
; Folding = -
; DisableDebugger