;ProcessorInfo
;~~~~~~~~~~~~~

Procedure.s GetProcessorName()
Size=#MAX_PATH
Name$=Space(Size)
Result=RegOpenKeyEx_(#HKEY_LOCAL_MACHINE,"HARDWARE\DESCRIPTION\System\CentralProcessor\0",0,#KEY_ALL_ACCESS,@Key)
If Result=0
RegQueryValueEx_(Key,"ProcessorNameString",0,0,@Name$,@Size)
RegCloseKey_(Key)
EndIf
ProcedureReturn Name$
EndProcedure

Procedure GetProcessorMHz()
Size=4
Result=RegOpenKeyEx_(#HKEY_LOCAL_MACHINE,"HARDWARE\DESCRIPTION\System\CentralProcessor\0",0,#KEY_ALL_ACCESS,@Key)
If Result=0
RegQueryValueEx_(Key,"~MHz",0,0,@MHz,@Size)
RegCloseKey_(Key) 
EndIf
ProcedureReturn MHz
EndProcedure


Procedure.s GetProcessorIdentifier()
Size=#MAX_PATH
Identifier$=Space(Size)
Result=RegOpenKeyEx_(#HKEY_LOCAL_MACHINE,"HARDWARE\DESCRIPTION\System\CentralProcessor\0",0,#KEY_ALL_ACCESS,@Key)
If Result=0
RegQueryValueEx_(Key,"Identifier",0,0,@Identifier$,@Size)
RegCloseKey_(Key)
EndIf
ProcedureReturn Identifier$
EndProcedure

Procedure.s GetProcessorVendorIdentifier()
Size=#MAX_PATH
VendorIdentifier$=Space(Size)
Result=RegOpenKeyEx_(#HKEY_LOCAL_MACHINE,"HARDWARE\DESCRIPTION\System\CentralProcessor\0",0,#KEY_ALL_ACCESS,@Key)
If Result=0
RegQueryValueEx_(Key,"VendorIdentifier",0,0,@VendorIdentifier$,@Size)
RegCloseKey_(Key)
EndIf
ProcedureReturn VendorIdentifier$
EndProcedure

Procedure.s GetProcessorVendorIdentifier2()
VendorIdentifier$=Space(12)+Chr(0)
!XOR EAX,EAX
!CPUID
!MOV EAX,[esp]
!MOV [EAX],ebx
!MOV [EAX+8],ecx
!MOV [EAX+4],edx
ProcedureReturn VendorIdentifier$
EndProcedure

Procedure GetCpuType()
CPU.System_Info
GetSystemInfo_(@CPU)
ProcedureReturn CPU\dwProcessorType
EndProcedure


A$="Name: "+GetProcessorName()+#LF$
A$+"MHz: "+Str(GetProcessorMHz())+#LF$
A$+"Identifier: "+GetProcessorIdentifier()+#LF$
A$+"VendorIdentifier: "+GetProcessorVendorIdentifier()+#LF$
A$+"Typ: "+Str(GetCpuType())
MessageRequester("Processor info:",A$)
; IDE Options = PureBasic v3.94 Beta 2 - Windows x86
; DisableDebugger