Procedure GetRenderTargetDDS();returns the DirectDrawSurface of the target buffer set with UseBuffer() 
!extrn _PB_Sprite_CurrentBitmap 
!MOV Eax,[_PB_Sprite_CurrentBitmap] 
ProcedureReturn 
EndProcedure 



InitSprite() 
OpenScreen(800,600,16,"BitBlt test") 

CreateSprite(1,128,128,#PB_Sprite_Memory) ;If you want to use the Sprite with BitBlt_() you should always created it with the flags #PB_Sprite_Memory (or it will be really slow) 

StartDrawing(SpriteOutput(1)) 
Circle(64,64,32,#Red) 
StopDrawing() 

*RenderTargetDDS.IDirectDrawSurface7=GetRenderTargetDDS(); the DirectDrawSurface of the target buffer (here Backbuffer) 

*RenderTargetDDS\GetDC(@TargetDC);Get the Device Context of the render target 
SrcDC=StartDrawing(SpriteOutput(1));Get the Device Context of the Sprite 

For count=1 To 100 
;BitBlt_(TargetDC,DestXPos   ,DestYPos   ,Width,Height,SrcDC,SrcX,SrcY,ROP) 
BitBlt_( TargetDC,Random(800),Random(600),128  ,128   ,SrcDC,0   ,0   ,#SRCINVERT) ;Blit the Sprite to the render-target 
Next 

StopDrawing(); release the Device Context of the Sprite 
*RenderTargetDDS\ReleaseDC(TargetDC); release the Device Context of the render-target 

FlipBuffers() 

Delay(5000) 
; IDE Options = PureBasic v3.94 (Windows - x86)
; CursorPosition = 32
; FirstLine = 1
; Folding = -